// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.quadrige2.core.dao.data.measurement;

import fr.ifremer.quadrige2.core.dao.administration.program.Program;
import fr.ifremer.quadrige2.core.dao.administration.user.Department;
import fr.ifremer.quadrige2.core.dao.data.sample.Sample;
import fr.ifremer.quadrige2.core.dao.data.samplingoperation.SamplingOperation;
import fr.ifremer.quadrige2.core.dao.data.survey.Survey;
import fr.ifremer.quadrige2.core.dao.referential.AnalysisInstrument;
import fr.ifremer.quadrige2.core.dao.referential.NumericalPrecision;
import fr.ifremer.quadrige2.core.dao.referential.ObjectType;
import fr.ifremer.quadrige2.core.dao.referential.PrecisionType;
import fr.ifremer.quadrige2.core.dao.referential.QualityFlag;
import fr.ifremer.quadrige2.core.dao.referential.pmfm.Pmfm;
import fr.ifremer.quadrige2.core.dao.referential.pmfm.QualitativeValue;
import fr.ifremer.quadrige2.core.dao.referential.taxon.ReferenceTaxon;
import fr.ifremer.quadrige2.core.dao.referential.taxon.TaxonGroup;
import fr.ifremer.quadrige2.core.dao.referential.taxon.TaxonName;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Résultat de mesure faisant l'objet d'une mesure unique pour un taxon, ou un regroupement de taxon
 * particulier.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TaxonMeasurement
    implements Serializable, Comparable<TaxonMeasurement>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -9127422289063735219L;

    // Generate 16 attributes
    private Integer taxonMeasId;

    /**
     * Identifiant interne du résultat
     * @return this.taxonMeasId Integer
     */
    public Integer getTaxonMeasId()
    {
        return this.taxonMeasId;
    }

    /**
     * Identifiant interne du résultat
     * @param taxonMeasIdIn Integer
     */
    public void setTaxonMeasId(Integer taxonMeasIdIn)
    {
        this.taxonMeasId = taxonMeasIdIn;
    }

    private Integer objectId;

    /**
     * Identifiant interne de donnnée in situ de référence (passage, prélèvement, prélèvement)
     * @return this.objectId Integer
     */
    public Integer getObjectId()
    {
        return this.objectId;
    }

    /**
     * Identifiant interne de donnnée in situ de référence (passage, prélèvement, prélèvement)
     * @param objectIdIn Integer
     */
    public void setObjectId(Integer objectIdIn)
    {
        this.objectId = objectIdIn;
    }

    private Integer taxonMeasIndivId;

    /**
     * Le numéro de l'individu mesuré pour les résultats sur taxon ayant plusieurs individus
     * @return this.taxonMeasIndivId Integer
     */
    public Integer getTaxonMeasIndivId()
    {
        return this.taxonMeasIndivId;
    }

    /**
     * Le numéro de l'individu mesuré pour les résultats sur taxon ayant plusieurs individus
     * @param taxonMeasIndivIdIn Integer
     */
    public void setTaxonMeasIndivId(Integer taxonMeasIndivIdIn)
    {
        this.taxonMeasIndivId = taxonMeasIndivIdIn;
    }

    private Float taxonMeasNumerValue;

    /**
     * La valeur du résultat si elle n'est pas qualitative
     * @return this.taxonMeasNumerValue Float
     */
    public Float getTaxonMeasNumerValue()
    {
        return this.taxonMeasNumerValue;
    }

    /**
     * La valeur du résultat si elle n'est pas qualitative
     * @param taxonMeasNumerValueIn Float
     */
    public void setTaxonMeasNumerValue(Float taxonMeasNumerValueIn)
    {
        this.taxonMeasNumerValue = taxonMeasNumerValueIn;
    }

    private Float taxonMeasPrecisionValue;

    /**
     * La valeur de l'incertitude. Ex : 2 (%) ou 0,01 (dégrés)
     * @return this.taxonMeasPrecisionValue Float
     */
    public Float getTaxonMeasPrecisionValue()
    {
        return this.taxonMeasPrecisionValue;
    }

    /**
     * La valeur de l'incertitude. Ex : 2 (%) ou 0,01 (dégrés)
     * @param taxonMeasPrecisionValueIn Float
     */
    public void setTaxonMeasPrecisionValue(Float taxonMeasPrecisionValueIn)
    {
        this.taxonMeasPrecisionValue = taxonMeasPrecisionValueIn;
    }

    private Double taxonMeasDigitNumber;

    /**
     * Nombre de chiffre après la virgule du résulat. Ex : si on saisit 10.00, il faut conserver 2
     * comme information
     * @return this.taxonMeasDigitNumber Double
     */
    public Double getTaxonMeasDigitNumber()
    {
        return this.taxonMeasDigitNumber;
    }

    /**
     * Nombre de chiffre après la virgule du résulat. Ex : si on saisit 10.00, il faut conserver 2
     * comme information
     * @param taxonMeasDigitNumberIn Double
     */
    public void setTaxonMeasDigitNumber(Double taxonMeasDigitNumberIn)
    {
        this.taxonMeasDigitNumber = taxonMeasDigitNumberIn;
    }

    private Date taxonMeasControlDt;

    /**
     * Date de contrôle
     * @return this.taxonMeasControlDt Date
     */
    public Date getTaxonMeasControlDt()
    {
        return this.taxonMeasControlDt;
    }

    /**
     * Date de contrôle
     * @param taxonMeasControlDtIn Date
     */
    public void setTaxonMeasControlDt(Date taxonMeasControlDtIn)
    {
        this.taxonMeasControlDt = taxonMeasControlDtIn;
    }

    private Date taxonMeasValidDt;

    /**
     * Date de validation
     * @return this.taxonMeasValidDt Date
     */
    public Date getTaxonMeasValidDt()
    {
        return this.taxonMeasValidDt;
    }

    /**
     * Date de validation
     * @param taxonMeasValidDtIn Date
     */
    public void setTaxonMeasValidDt(Date taxonMeasValidDtIn)
    {
        this.taxonMeasValidDt = taxonMeasValidDtIn;
    }

    private Date taxonMeasQualifDt;

    /**
     * Date de la qualification du résultat
     * @return this.taxonMeasQualifDt Date
     */
    public Date getTaxonMeasQualifDt()
    {
        return this.taxonMeasQualifDt;
    }

    /**
     * Date de la qualification du résultat
     * @param taxonMeasQualifDtIn Date
     */
    public void setTaxonMeasQualifDt(Date taxonMeasQualifDtIn)
    {
        this.taxonMeasQualifDt = taxonMeasQualifDtIn;
    }

    private String taxonMeasQualifCm;

    /**
     * Commentaire sur la qualification du résultat
     * Un commentaire de qualification est obligatoire si la mesure est douteuse ou mauvaise.
     * @return this.taxonMeasQualifCm String
     */
    public String getTaxonMeasQualifCm()
    {
        return this.taxonMeasQualifCm;
    }

    /**
     * Commentaire sur la qualification du résultat
     * Un commentaire de qualification est obligatoire si la mesure est douteuse ou mauvaise.
     * @param taxonMeasQualifCmIn String
     */
    public void setTaxonMeasQualifCm(String taxonMeasQualifCmIn)
    {
        this.taxonMeasQualifCm = taxonMeasQualifCmIn;
    }

    private String taxonMeasCm;

    /**
     * Commentaire sur le résultat sur taxon
     * @return this.taxonMeasCm String
     */
    public String getTaxonMeasCm()
    {
        return this.taxonMeasCm;
    }

    /**
     * Commentaire sur le résultat sur taxon
     * @param taxonMeasCmIn String
     */
    public void setTaxonMeasCm(String taxonMeasCmIn)
    {
        this.taxonMeasCm = taxonMeasCmIn;
    }

    private Timestamp updateDt;

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @return this.updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param updateDtIn Timestamp
     */
    public void setUpdateDt(Timestamp updateDtIn)
    {
        this.updateDt = updateDtIn;
    }

    private String parCd;

    /**
     * @deprecated (filled by synchro)
     * @return this.parCd String
     */
    public String getParCd()
    {
        return this.parCd;
    }

    /**
     * @deprecated (filled by synchro)
     * @param parCdIn String
     */
    public void setParCd(String parCdIn)
    {
        this.parCd = parCdIn;
    }

    private Integer matrixId;

    /**
     * @deprecated (filled by synchro)
     * @return this.matrixId Integer
     */
    public Integer getMatrixId()
    {
        return this.matrixId;
    }

    /**
     * @deprecated (filled by synchro)
     * @param matrixIdIn Integer
     */
    public void setMatrixId(Integer matrixIdIn)
    {
        this.matrixId = matrixIdIn;
    }

    private Integer fractionId;

    /**
     * @deprecated (filled by synchro)
     * @return this.fractionId Integer
     */
    public Integer getFractionId()
    {
        return this.fractionId;
    }

    /**
     * @deprecated (filled by synchro)
     * @param fractionIdIn Integer
     */
    public void setFractionId(Integer fractionIdIn)
    {
        this.fractionId = fractionIdIn;
    }

    private Integer methodId;

    /**
     * @deprecated (filled by synchro)
     * @return this.methodId Integer
     */
    public Integer getMethodId()
    {
        return this.methodId;
    }

    /**
     * @deprecated (filled by synchro)
     * @param methodIdIn Integer
     */
    public void setMethodId(Integer methodIdIn)
    {
        this.methodId = methodIdIn;
    }

    // Generate 16 associations
    private Sample sample;

    /**
     * Liste les échantillons prélevés lors d'un passage sur un lieu de surveillance.
     * @return this.sample Sample
     */
    public Sample getSample()
    {
        return this.sample;
    }

    /**
     * Liste les échantillons prélevés lors d'un passage sur un lieu de surveillance.
     * @param sampleIn Sample
     */
    public void setSample(Sample sampleIn)
    {
        this.sample = sampleIn;
    }

    private TaxonGroup taxonGroup;

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Liste l'ensemble de taxons ayant les mêmes caractéristiques pour le critère pris en compte.
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    private Pmfm pmfm;

    /**
     * Liste les quadruplets paramètre, méthode, support, fraction.
     * @return this.pmfm Pmfm
     */
    public Pmfm getPmfm()
    {
        return this.pmfm;
    }

    /**
     * Liste les quadruplets paramètre, méthode, support, fraction.
     * @param pmfmIn Pmfm
     */
    public void setPmfm(Pmfm pmfmIn)
    {
        this.pmfm = pmfmIn;
    }

    private ReferenceTaxon referenceTaxon;

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @return this.referenceTaxon ReferenceTaxon
     */
    public ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    /**
     * Liste des taxons qui sont la référence.
     * l'ID référent est indépendant des ID taxon car les taxons peuvent être référents à un moment
     * et ne
     * plus l'être par la suite.
     * Toutes les données du système doivent donc être reliées au référent et non au taxon qui sont
     * référents à un moment mais ne peuvent plus l'être par la suite.
     * Le fonctionnement dans la table TAXON_NAME est le suivant :
     * - REF_TAXON_ID est toujours renseigné
     * - si TAXON_NAME_IS_REFER est à vrai, il s'agit d'un taxon référent (toujours le cas s'il
     * s'agit d'un
     * taxon virtuel)
     * - sinon c'est un synonyme
     * Un taxon référent qui devient synonyme voit donc son statut TAXON_NAME_IS_REFER changer et le
     * nouveau taxon référent qui le remplace récupère l'information REF_TAXON_ID
     * NB : c'était le comportement initialement prévu.
     * En réalité, lorsqu'un taxon référent T1-R1 devient synonyme d'un nouveau taxon référent T2,
     * le taxon
     * T2 prend un nouveau code référent R2 et donc le taxon T1 est lié à R2 (et tous les synonymes
     * et les
     * résultats qu'il pouvait avoir).
     * Ce mécanisme a été adopté car il fallait distinguer 2 cas :
     * 1- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qu'on crée T2 : on aurait
     * alors
     * pu utiliser le même REF_TAXON_ID R1 au lieu d'en créer un et ne pas mettre à jour les autres
     * synonymes, résultats...
     * 2- cas d'un taxon référent T1-R1 qui devient synonyme d'un référent qui existe déjà T2-R2 (et
     * qui
     * aurait déjà d'autres synonymes, résultats...), dans ce cas le remplacement de la référence R1
     * pour
     * R2 est nécessaire
     * La modélisation pourrait être revue car la table REFENCE_TAXON ne se justifie alors plus, on
     * pourrait directement utiliser une référence à la colonne TAXON_NAME_ID pour désigner les
     * référents
     * @param referenceTaxonIn ReferenceTaxon
     */
    public void setReferenceTaxon(ReferenceTaxon referenceTaxonIn)
    {
        this.referenceTaxon = referenceTaxonIn;
    }

    private Department recorderDepartment;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.recorderDepartment Department
     */
    public Department getRecorderDepartment()
    {
        return this.recorderDepartment;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param recorderDepartmentIn Department
     */
    public void setRecorderDepartment(Department recorderDepartmentIn)
    {
        this.recorderDepartment = recorderDepartmentIn;
    }

    private QualityFlag qualityFlag;

    /**
     * Liste des niveaux de qualification.
     * @return this.qualityFlag QualityFlag
     */
    public QualityFlag getQualityFlag()
    {
        return this.qualityFlag;
    }

    /**
     * Liste des niveaux de qualification.
     * @param qualityFlagIn QualityFlag
     */
    public void setQualityFlag(QualityFlag qualityFlagIn)
    {
        this.qualityFlag = qualityFlagIn;
    }

    private Collection<Program> programs = new HashSet<Program>();

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @return this.programs Collection<Program>
     */
    public Collection<Program> getPrograms()
    {
        return this.programs;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param programsIn Collection<Program>
     */
    public void setPrograms(Collection<Program> programsIn)
    {
        this.programs = programsIn;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToAdd Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addPrograms(Program elementToAdd)
    {
        return this.programs.add(elementToAdd);
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * @param elementToRemove Program
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removePrograms(Program elementToRemove)
    {
        return this.programs.remove(elementToRemove);
    }

    private NumericalPrecision numericalPrecision;

    /**
     * Liste des précisions numériques.
     * @return this.numericalPrecision NumericalPrecision
     */
    public NumericalPrecision getNumericalPrecision()
    {
        return this.numericalPrecision;
    }

    /**
     * Liste des précisions numériques.
     * @param numericalPrecisionIn NumericalPrecision
     */
    public void setNumericalPrecision(NumericalPrecision numericalPrecisionIn)
    {
        this.numericalPrecision = numericalPrecisionIn;
    }

    private PrecisionType precisionType;

    /**
     * type d'incertitude des mesures d'un paramètre dans une stratégie.
     * @return this.precisionType PrecisionType
     */
    public PrecisionType getPrecisionType()
    {
        return this.precisionType;
    }

    /**
     * type d'incertitude des mesures d'un paramètre dans une stratégie.
     * @param precisionTypeIn PrecisionType
     */
    public void setPrecisionType(PrecisionType precisionTypeIn)
    {
        this.precisionType = precisionTypeIn;
    }

    private Department department;

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @return this.department Department
     */
    public Department getDepartment()
    {
        return this.department;
    }

    /**
     * Liste les départements ou services auxquels sont rattachés les agents
     * @param departmentIn Department
     */
    public void setDepartment(Department departmentIn)
    {
        this.department = departmentIn;
    }

    private ObjectType objectType;

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @return this.objectType ObjectType
     */
    public ObjectType getObjectType()
    {
        return this.objectType;
    }

    /**
     * Liste des types d'objets qui peuvent être associés à la photo ou à un résultat. Cette liste
     * ne peut
     * pas être modifiée par l'utilisateur.
     * @param objectTypeIn ObjectType
     */
    public void setObjectType(ObjectType objectTypeIn)
    {
        this.objectType = objectTypeIn;
    }

    private AnalysisInstrument analysisInstrument;

    /**
     * Liste les engins d'analyse ou de prélèvement (au sens marque/modèle et non numéro de série).
     * @return this.analysisInstrument AnalysisInstrument
     */
    public AnalysisInstrument getAnalysisInstrument()
    {
        return this.analysisInstrument;
    }

    /**
     * Liste les engins d'analyse ou de prélèvement (au sens marque/modèle et non numéro de série).
     * @param analysisInstrumentIn AnalysisInstrument
     */
    public void setAnalysisInstrument(AnalysisInstrument analysisInstrumentIn)
    {
        this.analysisInstrument = analysisInstrumentIn;
    }

    private QualitativeValue qualitativeValue;

    /**
     * Liste des valeurs qualitatives associées aux paramètres.
     * @return this.qualitativeValue QualitativeValue
     */
    public QualitativeValue getQualitativeValue()
    {
        return this.qualitativeValue;
    }

    /**
     * Liste des valeurs qualitatives associées aux paramètres.
     * @param qualitativeValueIn QualitativeValue
     */
    public void setQualitativeValue(QualitativeValue qualitativeValueIn)
    {
        this.qualitativeValue = qualitativeValueIn;
    }

    private Survey survey;

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @return this.survey Survey
     */
    public Survey getSurvey()
    {
        return this.survey;
    }

    /**
     * Liste les différents passages effectués sur un lieu de surveillance.
     * Liste les différents passages effectués sur un lieu de surveillance.
     * @param surveyIn Survey
     */
    public void setSurvey(Survey surveyIn)
    {
        this.survey = surveyIn;
    }

    private SamplingOperation samplingOperation;

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @return this.samplingOperation SamplingOperation
     */
    public SamplingOperation getSamplingOperation()
    {
        return this.samplingOperation;
    }

    /**
     * Liste les prélévements effectués lors d'un passage.
     * @param samplingOperationIn SamplingOperation
     */
    public void setSamplingOperation(SamplingOperation samplingOperationIn)
    {
        this.samplingOperation = samplingOperationIn;
    }

    private TaxonName taxonName;

    /**
     * Liste les taxons (interface avec ERMS)
     * @return this.taxonName TaxonName
     */
    public TaxonName getTaxonName()
    {
        return this.taxonName;
    }

    /**
     * Liste les taxons (interface avec ERMS)
     * @param taxonNameIn TaxonName
     */
    public void setTaxonName(TaxonName taxonNameIn)
    {
        this.taxonName = taxonNameIn;
    }

    /**
     * Returns <code>true</code> if the argument is an TaxonMeasurement instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonMeasurement))
        {
            return false;
        }
        final TaxonMeasurement that = (TaxonMeasurement)object;
        if (this.taxonMeasId == null || that.getTaxonMeasId() == null || !this.taxonMeasId.equals(that.getTaxonMeasId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.taxonMeasId == null ? 0 : this.taxonMeasId.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TaxonMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TaxonMeasurement}.
         * @return new TaxonMeasurementImpl()
         */
        public static TaxonMeasurement newInstance()
        {
            return new TaxonMeasurementImpl();
        }

        /**
         * Constructs a new instance of {@link TaxonMeasurement}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param objectId Integer
         * @param updateDt Timestamp
         * @param pmfm Pmfm
         * @param qualityFlag QualityFlag
         * @param objectType ObjectType
         * @return newInstance
         */
        public static TaxonMeasurement newInstance(Integer objectId, Timestamp updateDt, Pmfm pmfm, QualityFlag qualityFlag, ObjectType objectType)
        {
            final TaxonMeasurement entity = new TaxonMeasurementImpl();
            entity.setObjectId(objectId);
            entity.setUpdateDt(updateDt);
            entity.setPmfm(pmfm);
            entity.setQualityFlag(qualityFlag);
            entity.setObjectType(objectType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TaxonMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param objectId Integer
         * @param taxonMeasIndivId Integer
         * @param taxonMeasNumerValue Float
         * @param taxonMeasPrecisionValue Float
         * @param taxonMeasDigitNumber Double
         * @param taxonMeasControlDt Date
         * @param taxonMeasValidDt Date
         * @param taxonMeasQualifDt Date
         * @param taxonMeasQualifCm String
         * @param taxonMeasCm String
         * @param updateDt Timestamp
         * @param parCd String
         * @param matrixId Integer
         * @param fractionId Integer
         * @param methodId Integer
         * @param sample Sample
         * @param taxonGroup TaxonGroup
         * @param pmfm Pmfm
         * @param referenceTaxon ReferenceTaxon
         * @param recorderDepartment Department
         * @param qualityFlag QualityFlag
         * @param programs Collection<Program>
         * @param numericalPrecision NumericalPrecision
         * @param precisionType PrecisionType
         * @param department Department
         * @param objectType ObjectType
         * @param analysisInstrument AnalysisInstrument
         * @param qualitativeValue QualitativeValue
         * @param survey Survey
         * @param samplingOperation SamplingOperation
         * @param taxonName TaxonName
         * @return newInstance TaxonMeasurement
         */
        public static TaxonMeasurement newInstance(Integer objectId, Integer taxonMeasIndivId, Float taxonMeasNumerValue, Float taxonMeasPrecisionValue, Double taxonMeasDigitNumber, Date taxonMeasControlDt, Date taxonMeasValidDt, Date taxonMeasQualifDt, String taxonMeasQualifCm, String taxonMeasCm, Timestamp updateDt, String parCd, Integer matrixId, Integer fractionId, Integer methodId, Sample sample, TaxonGroup taxonGroup, Pmfm pmfm, ReferenceTaxon referenceTaxon, Department recorderDepartment, QualityFlag qualityFlag, Collection<Program> programs, NumericalPrecision numericalPrecision, PrecisionType precisionType, Department department, ObjectType objectType, AnalysisInstrument analysisInstrument, QualitativeValue qualitativeValue, Survey survey, SamplingOperation samplingOperation, TaxonName taxonName)
        {
            final TaxonMeasurement entity = new TaxonMeasurementImpl();
            entity.setObjectId(objectId);
            entity.setTaxonMeasIndivId(taxonMeasIndivId);
            entity.setTaxonMeasNumerValue(taxonMeasNumerValue);
            entity.setTaxonMeasPrecisionValue(taxonMeasPrecisionValue);
            entity.setTaxonMeasDigitNumber(taxonMeasDigitNumber);
            entity.setTaxonMeasControlDt(taxonMeasControlDt);
            entity.setTaxonMeasValidDt(taxonMeasValidDt);
            entity.setTaxonMeasQualifDt(taxonMeasQualifDt);
            entity.setTaxonMeasQualifCm(taxonMeasQualifCm);
            entity.setTaxonMeasCm(taxonMeasCm);
            entity.setUpdateDt(updateDt);
            entity.setParCd(parCd);
            entity.setMatrixId(matrixId);
            entity.setFractionId(fractionId);
            entity.setMethodId(methodId);
            entity.setSample(sample);
            entity.setTaxonGroup(taxonGroup);
            entity.setPmfm(pmfm);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setRecorderDepartment(recorderDepartment);
            entity.setQualityFlag(qualityFlag);
            entity.setPrograms(programs);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setPrecisionType(precisionType);
            entity.setDepartment(department);
            entity.setObjectType(objectType);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setQualitativeValue(qualitativeValue);
            entity.setSurvey(survey);
            entity.setSamplingOperation(samplingOperation);
            entity.setTaxonName(taxonName);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TaxonMeasurement o)
    {
        int cmp = 0;
        if (this.getTaxonMeasId() != null)
        {
            cmp = this.getTaxonMeasId().compareTo(o.getTaxonMeasId());
        }
        else
        {
            if (this.getObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectId().compareTo(o.getObjectId()));
            }
            if (this.getTaxonMeasIndivId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasIndivId().compareTo(o.getTaxonMeasIndivId()));
            }
            if (this.getTaxonMeasNumerValue() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasNumerValue().compareTo(o.getTaxonMeasNumerValue()));
            }
            if (this.getTaxonMeasPrecisionValue() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasPrecisionValue().compareTo(o.getTaxonMeasPrecisionValue()));
            }
            if (this.getTaxonMeasDigitNumber() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasDigitNumber().compareTo(o.getTaxonMeasDigitNumber()));
            }
            if (this.getTaxonMeasControlDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasControlDt().compareTo(o.getTaxonMeasControlDt()));
            }
            if (this.getTaxonMeasValidDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasValidDt().compareTo(o.getTaxonMeasValidDt()));
            }
            if (this.getTaxonMeasQualifDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasQualifDt().compareTo(o.getTaxonMeasQualifDt()));
            }
            if (this.getTaxonMeasQualifCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasQualifCm().compareTo(o.getTaxonMeasQualifCm()));
            }
            if (this.getTaxonMeasCm() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getTaxonMeasCm().compareTo(o.getTaxonMeasCm()));
            }
            if (this.getUpdateDt() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDt().compareTo(o.getUpdateDt()));
            }
            if (this.getParCd() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getParCd().compareTo(o.getParCd()));
            }
            if (this.getMatrixId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMatrixId().compareTo(o.getMatrixId()));
            }
            if (this.getFractionId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getFractionId().compareTo(o.getFractionId()));
            }
            if (this.getMethodId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getMethodId().compareTo(o.getMethodId()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TaxonMeasurement.java merge-point
}